VERSION 5.00
Begin VB.Form Arcade 
   BackColor       =   &H80000000&
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "SloMo Arcade Emulator"
   ClientHeight    =   3840
   ClientLeft      =   150
   ClientTop       =   435
   ClientWidth     =   3840
   Icon            =   "Arcade.frx":0000
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3840
   ScaleWidth      =   3840
   StartUpPosition =   2  'CenterScreen
   Begin VB.PictureBox ArcadeScreen 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BackColor       =   &H00000000&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   3840
      Left            =   0
      ScaleHeight     =   256
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   256
      TabIndex        =   0
      Top             =   0
      Width           =   3840
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuReset 
         Caption         =   "&Reset"
      End
      Begin VB.Menu mnuExit 
         Caption         =   "&Exit"
      End
   End
   Begin VB.Menu mnuSize 
      Caption         =   "&Size"
      Begin VB.Menu mnuScreenX1 
         Caption         =   "x1"
      End
      Begin VB.Menu mnuScreenX2 
         Caption         =   "x2"
      End
      Begin VB.Menu mnuScreenX3 
         Caption         =   "x3"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuAbout 
         Caption         =   "&About"
      End
   End
End
Attribute VB_Name = "Arcade"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Private Sub ArcadeScreen_KeyDown(KeyCode As Integer, Shift As Integer)
    keyboard(KeyCode) = 1
End Sub

Private Sub ArcadeScreen_KeyUp(KeyCode As Integer, Shift As Integer)
    keyboard(KeyCode) = 0
End Sub

Private Sub Form_Unload(Cancel As Integer)
  End
End Sub

Private Sub mnuAbout_Click()
  Dim message As String
  message = "SloMo Arcade Emulator v0.11..." & vbCrLf
  message = message & "Updated for the lulz by Don Jarrett, 2017." & vbCrLf & vbCrLf
  message = message & "Keyboard layout:" & vbCrLf
  message = message & "1 - 1P Start" & vbCrLf
  message = message & "3 - Insert Coin" & vbCrLf
  message = message & "Ctrl - Fire" & vbCrLf & vbCrLf
  message = message & "http://icanhasdomainplease.com/software"
  MsgBox message, vbOKOnly, "SloMo"
End Sub

Private Sub mnuExit_Click()
  M6502_Free
  End
End Sub

Private Sub mnuReset_Click()
  Dim FrameTime As Double
  Dim TotalTime As Double
  Dim NumberOfFrames As Double
  
  M6502_Init 9000
  M6502_Reset
  CPURunning = True
  
  NumberOfFrames = 0
  Do While keyboard(vbKeyEscape) = 0
    FrameTime = Timer
    For test = 1 To 4000
        M6502_Exec
    Next test
    RedrawScreen
    DoEvents
    TotalTime = TotalTime + (Timer - FrameTime)
    NumberOfFrames = NumberOfFrames + 1
    Caption = "SloMo - " & Format(1 / (TotalTime / NumberOfFrames), "0.0") & "fps"
  Loop
  
  mnuExit_Click
  
End Sub
Private Sub Form_Load()
  Main
  mnuScreenX2_Click
  Arcade.Show
  mnuReset_Click
End Sub

Private Sub mnuScreenX1_Click()

    ArcadeScreen.Width = Screen.TwipsPerPixelX * 256&
    ArcadeScreen.Height = Screen.TwipsPerPixelY * 256&
    Arcade.Width = ArcadeScreen.Width + 90
    Arcade.Height = ArcadeScreen.Height + 660
    
End Sub

Private Sub mnuScreenX2_Click()

    ArcadeScreen.Width = Screen.TwipsPerPixelX * 512&
    ArcadeScreen.Height = Screen.TwipsPerPixelY * 512&
    Arcade.Width = ArcadeScreen.Width + 90
    Arcade.Height = ArcadeScreen.Height + 660

End Sub

Private Sub mnuScreenX3_Click()

    ArcadeScreen.Width = Screen.TwipsPerPixelX * 768&
    ArcadeScreen.Height = Screen.TwipsPerPixelY * 768&
    Arcade.Width = ArcadeScreen.Width + 90
    Arcade.Height = ArcadeScreen.Height + 660

End Sub
